"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class ReportedVariant(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "alternate",
        "calledGenotypes",
        "chromosome",
        "position",
        "reference",
        "reportEvents",
        "versionControl",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_2_1_0 import reports as reports_2_1_0

        return {
            "calledGenotypes": reports_2_1_0.CalledGenotype,
            "reportEvents": reports_2_1_0.ReportEvent,
            "versionControl": reports_2_1_0.VersionControl,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_2_1_0 import reports as reports_2_1_0

        return {
            "Gel_BioInf_Models.CalledGenotype": reports_2_1_0.CalledGenotype,
            "Gel_BioInf_Models.ReportEvent": reports_2_1_0.ReportEvent,
            "Gel_BioInf_Models.VersionControl": reports_2_1_0.VersionControl,
            "Gel_BioInf_Models.ReportedVariant": reports_2_1_0.ReportedVariant,
        }

    __slots__ = [
        "alternate",
        "calledGenotypes",
        "chromosome",
        "position",
        "reference",
        "reportEvents",
        "versionControl",
        "additionalNumericVariantAnnotations",
        "additionalTextualVariantAnnotations",
        "comments",
        "dbSNPid",
    ]

    def __init__(
        self,
        alternate,
        calledGenotypes,
        chromosome,
        position,
        reference,
        reportEvents,
        versionControl,
        additionalNumericVariantAnnotations=None,
        additionalTextualVariantAnnotations=None,
        comments=None,
        dbSNPid=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_2_1_0.ReportedVariant model.

        :param alternate:
            alternate: Alternate Allele sequence, the same provided in vcf
        :type alternate: str
        :param calledGenotypes:
            array of genotypes for the family
        :type calledGenotypes: list[CalledGenotype]
        :param chromosome:
            chromosome, named as: 1-22,X,Y,MT or other contig names as defined in
            the BAM header
        :type chromosome: str
        :param position:
            position: Position 1-based
        :type position: int
        :param reference:
            reference: Reference Allele sequence, the same provided in vcf
        :type reference: str
        :param reportEvents:
            This is the scores across multiple modes of inheritance, for each
            model of inheritance analyzed,     the variants can have
            only one Report event.
        :type reportEvents: list[ReportEvent]
        :param versionControl:
            Model version number
        :type versionControl: VersionControl
        :param additionalNumericVariantAnnotations:
            For Example (Allele Frequency, sift, polyphen, mutationTaster, CADD.
            ..)
        :type additionalNumericVariantAnnotations: None | dict[str, float]
        :param additionalTextualVariantAnnotations:
            For example HGMD ID)
        :type additionalTextualVariantAnnotations: None | dict[str, str]
        :param comments:
            Comments
        :type comments: None | list[str]
        :param dbSNPid:
            variant ID in dbSNP
        :type dbSNPid: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "2.1.0"
